﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Windows;
using Autodesk.AutoCAD.Geometry;

[assembly: CommandClass(typeof(AcedCmdTest.MyClass))]

namespace AcedCmdTest
{
	
	/// <summary>
	/// Description of MyClass.
	/// </summary>
	public class MyClass
	{
		PaletteSet paletteSet;
		
		[DllImport("acad.exe", CallingConvention = CallingConvention.Cdecl, EntryPoint="acedCmd")]
		extern static int acedCmd(IntPtr pResbuf);
		
		public unsafe static int Command(ResultBuffer args)
		{
			if( !Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.IsApplicationContext )
				return acedCmd((IntPtr) args.UnmanagedObject.ToPointer());
			else
				return 0;
		}
		
		[CommandMethod("method1", CommandFlags.Redraw | CommandFlags.Session | CommandFlags.UsePickSet)]
		public void method1()
		{
			if (paletteSet == null)
			{
				paletteSet = new PaletteSet("acedcmdtest-paletteset");
				paletteSet.Add("default-control", new MyUserControl());
			}
			
			paletteSet.Visible = true;
		}
		
		// Klappt
		[CommandMethod("method2")]
		public void method2()
		{
			ResultBuffer args = new ResultBuffer();
			args.Add(new TypedValue(5005, "._circle"));
			args.Add(new TypedValue(5009, new Point3d(2.0, 2.0, 0.0)));
			args.Add(new TypedValue(5001, 4.0));
			int i = MyClass.Command(args);
			
			int a = 0;	
		}
		
	}
}